#!/usr/bin/perl

$input = "current_MP_chains_after_clustering.txt";	#listfile with chains to be distributed

#read folds file
open (FOLD, "folds.ls") || die "cannot open folds file \n";
while (my $in = <FOLD>){
	chomp $in;
	@in = split /\s+/, $in;
	push @protein, $in[0];
	push @fold, $in[1];
}
close FOLD;

#read folds files and add them to chains file
open (IN, $input) || die "cannot open input file \n";
open (OUT, ">datasets_all.ls") || die "cannot open output file \n";
while (my $in = <IN>){
	chomp $in;
	foreach $i (0..$#protein){
		if ($in =~ $protein[$i]){
			print OUT "$in\t$fold[$i]\n";	
		}
	}
}
close IN;
close OUT;

