#!/usr/bin/perl

#this is with correction!!! From not highest states 7*0.11 as baseline probability is subtracted

#====>
$independent = $ARGV[0];	#from 0..4
$protein = $ARGV[1];		#only required for name of input file

#$datasets = 5000;
#$datasets = 318391;		#independent 1 unbalanced
#$datasets = 284957;		#independent 2 unbalanced
#$datasets = 286570;		#independent 3 unbalanced
#$datasets = 300654;		#independent 4 unbalanced
#$datasets = 309274;		#independent 5 unbalanced
#$number_networks = 1;
#$total_counts = 9*$datasets*$number_networks;
#$total_counts = $datasets*$number_networks;		#for unbalanced
$algorithm = 1;	#0 = jury with maximal probabilities; 1 = add probabilities - higher;

#read in the data
#=====================================================
$linecount = -1;
foreach $ind ($independent..$independent){

  @prediction = ();

  foreach $mon (0..4){
	next if ($ind == $mon);
	$set = "$ind$mon";
print "$set\n";

	@out = ();
	$linecount = -1;
	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_unbal_nonrand_gaps2.5.2.dat";
#	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_unbal_nonrand_nogaps.2.dat";
#	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_MPbeta_unbal_nonrand_nogaps.2.dat";
#	$input = "train_10k/".$set."/testModel".($ind+1)."_sol_unbal_nonrand_nogaps.0.dat";
#	$input = "train_40k/".$set."/descriptors_PDB_9D_40000_w31.ind";
#	$input = "train_20ANNs_dssp_v2_scrambled/".$set."/descriptors_PDB_9D_5000_w31_v2_scrambled.ind";
#	$input = "train_20ANNs_dssp_v3/".$set."/descriptors_PDB_9D_5000_w31_v3.ind";
#	$input = "train_20ANNs_dssp_v4/".$set."/descriptors_PDB_9D_5000_w31_v4.ind";
#	$input = "train_20ANNs_dssp/".$set."/train_PDB_9D_5000_w31_props_dssp.ind1";
#	$input = "train_20ANNs_MPseq/".$set."/testModel_all_unbal_onlyStructures.0.dat";
#	$input = "train_20ANNs_dssp_v4/".$set."/testModel".($ind+1)."_all_unbal_nrand_nogaps.0.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MPalpha_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MPbeta_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MP_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_sol_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/";
#	$input = $protein."_test_".$ind.$mon.".2.dat";
	open (IN, $input) || die "cannot open input file $input\n";
	$flag = 0;
	$cnt = 0;
	while ($in = <IN>){
		chomp $in;
		$in =~ s/^\s+//;

		@pred = ();
		$cnt++;
		next if $cnt <= 2;
		$linecount++;
		@in = split /\s+/, $in;

		#get the true state
		$in1 = "";
		foreach $j (0..8){
			$in1 .= $in[$j]." ";
		}
		push @out, $in1;

		#get the predicted state
		foreach $j (9..17){
			push @pred, $in[$j];
		}

		#get the sum for normalization to get the probabilities
		$sum = 0;
		foreach $i (0..8){
			$pred[$i] += 0.15;
			$sum += $pred[$i];
		}
		#normalize to probabilities such that the sum of the probabilities over 4 ANNs is 1
		foreach $i (0..8){
			$pred[$i] /= $sum;
			$pred[$i] /= 4;
		}
		#make a histogram of the maximal elements, if jury prediction
		if ($algorithm == 0){
			$max_pred = 0;
			foreach $i (0..8){
				if ($pred[$i] > $max_pred){
					$max_pred = $pred[$i];
					$max_pred_element = $i;
				}
			}
			$prediction[$linecount][$max_pred_element]++;		#prediction matrix(lines, prediction probabilities)
		}
		#add the probabilities together, no jury prediction
		if ($algorithm == 1){
			foreach $i (0..8){
				$prediction[$linecount][$i] += $pred[$i];	#prediction matrix(lines, prediction probabilities)
			}
		}
		$flag = 0;
	}
	close IN;
  }
}

#get the 2-state probabilities from the sum of the probabilities over 4 ANNs
foreach $i (0..$linecount){

	#for 2-state TMhelix predictions
	$TMH = $prediction[$i][0] + ((7*0.111)/2);
#	$TMH = $prediction[$i][0];
	$noTMH = 0;
	foreach $j (1..8){
		$noTMH += $prediction[$i][$j];
	}
	$noTMH -= (7*0.111)/2;
#print "$out[$i]\t";
#print "$prediction[$i][0]\t$prediction[$i][1]\t$prediction[$i][2]\t$prediction[$i][3]\t$prediction[$i][4]\t$prediction[$i][5]\t$prediction[$i][6]\t$prediction[$i][7]\t$prediction[$i][8]\t";

	#for 2-state TMstrand predictions
	$TMS = $prediction[$i][1] + ((7*0.111)/2);
#	$TMS = $prediction[$i][1];
	$noTMS = 0;
	foreach $j (0,2..8){
		$noTMS += $prediction[$i][$j];
	}
	$noTMS -= (7*0.111)/2;
#print "$TMH\t$noTMH\n";
#print "$TMH\t$noTMH\t$TMS\t$noTMS\n";
	#compare the true state with TMhelix prediction
	@line = split /\s+/, $out[$i];
	if ($line[0] == 1 && $TMH >= $noTMH){
		$tmh_tmh++;
	}
	elsif ($line[0] == 1 && $TMH < $noTMH){
		$tmh_notmh++;
	}
	elsif ($line[0] == 0 && $TMH >= $noTMH){
		$notmh_tmh++;
	}
	elsif ($line[0] == 0 && $TMH < $noTMH){
		$notmh_notmh++;
	}

	#compare the true state with TMstrand prediction
	if ($line[1] == 1 && $TMS >= $noTMS){
		$tms_tms++;
	}
	elsif ($line[1] == 1 && $TMS < $noTMS){
		$tms_notms++;
	}
	elsif ($line[1] == 0 && $TMS >= $noTMS){
		$notms_tms++;
	}
	elsif ($line[1] == 0 && $TMS < $noTMS){
		$notms_notms++;
	}

	$tmh_tmh == ""     ? $tmh_tmh = 0 :
	$notmh_tmh == ""   ? $notmh_tmh = 0 :
	$tmh_notmh == ""   ? $tmh_notmh = 0 :
	$notmh_notmh == "" ? $notmh_notmh = 0 : print;

	$tms_tms == ""     ? $tms_tms = 0 :
	$notms_tms == ""   ? $notms_tms = 0 :
	$tms_notms == ""   ? $tms_notms = 0 :
	$notms_notms == "" ? $notms_notms = 0 : print;
#print "$TMH\t$noTMH\t$TMS\t$noTMS\t$tmh_tmh\t$tmh_notmh\t$notmh_tmh\t$notmh_notmh\n";
#print "$TMH\t$noTMH\t$TMS\t$noTMS\t$tms_tms\t$tms_notms\t$notms_tms\t$notms_notms\n";
}

print "counts";
print "\n\tP R E D I C T I O N\n";
print "OUT\tTMH\tnoTMH\n";
print "TMH\t";
printf "%.0f",$tmh_tmh;
print "\t";
printf "%.0f",$tmh_notmh;
print "\nnoTMH\t";
printf "%.0f",$notmh_tmh;
print "\t";
printf "%.0f",$notmh_notmh;
print "\n";

print "--------------------------------------------------";

print "\n\nnormalized to out";
print "\n\tP R E D I C T I O N\n";
print "OUT\tTMH\tnoTMH\n";
print "TMH\t";
printf "%.2f",$tmh_tmh    /($tmh_tmh + $tmh_notmh)*100;
print "\t";
printf "%.2f",$tmh_notmh  /($tmh_tmh + $tmh_notmh)*100;
print "\nnoTMH\t";
printf "%.2f",$notmh_tmh  /($notmh_tmh + $notmh_notmh)*100;
print "\t";
printf "%.2f",$notmh_notmh/($notmh_tmh + $notmh_notmh)*100;
print "\n";

print "==================================================";

print "\n\ncounts";
print "\n\tP R E D I C T I O N\n";
print "OUT\tTMS\tnoTMS\n";
print "TMS\t";
printf "%.0f",$tms_tms;
print "\t";
printf "%.0f",$tms_notms;
print "\nnoTMS\t";
printf "%.0f",$notms_tms;
print "\t";
printf "%.0f",$notms_notms;
print "\n";

print "--------------------------------------------------";

print "\n\nnormalized to out";
print "\n\tP R E D I C T I O N\n";
print "OUT\tTMS\tnoTMS\n";
print "TMS\t";
printf "%.2f",$tms_tms    /($tms_tms + $tms_notms)*100;
print "\t";
printf "%.2f",$tms_notms  /($tms_tms + $tms_notms)*100;
print "\nnoTMS\t";
printf "%.2f",$notms_tms  /($notms_tms + $notms_notms)*100;
print "\t";
printf "%.2f",$notms_notms/($notms_tms + $notms_notms)*100;
print "\n";

print "==================================================";

print "\n\n>per-residue TMH:\t";
printf "%.2f", (($tmh_tmh + $notmh_notmh)/($tmh_tmh + $tmh_notmh + $notmh_tmh + $notmh_notmh))*100;
print "\n";
print ">per-residue TMS:\t";
printf "%.2f", (($tms_tms + $notms_notms)/($tms_tms + $tms_notms + $notms_tms + $notms_notms))*100;
print "\n";





