#!/usr/bin/perl 


$dataset = $ARGV[0];	#starting from 1
$in_file = "/home/koehlej/projects/jufo/039_training_9D/datasets1/dataset".$dataset.".ls";
$out_file = "octopus_ds".$dataset.".octo_topo";

open (IN, $in_file) || die "cannot open input file $in_file\n";
open (OUT, ">".$out_file) || die "cannot open output file $out_file\n";
while ($in = <IN>){
	chomp $in;
#print "$in\n";
	@in = split /\s+/, $in;
	$octopus_file = "/home/koehlej/projects/jufo/039_training_9D/database_all/".$in[0].".octo_topo";
	open (OCTOPUS_FILE, $octopus_file) || die "cannot open Octopus file $octopus_file\n";

	$flag = "";
	$topo = "";
	$no_tm = "";
	while ($file = <OCTOPUS_FILE>){
		chomp $file;
		if ($file =~ /Sequence length:/){
			@file = split /\s+/, $file;
			$nres = $file[2]; 
		}

		if ($file =~ /SPOCTOPUS predicted topology/){
			$flag = 1;
		}
		if ($flag == 1 && $file !~ /SPOCTOPUS predicted topology/){
			if ($file =~ /regions/){
				$no_tm = 1;
			}
			$topo .= $file;
#print "$file\n";
		}
	}
	close OCTOPUS_FILE;
	@topo = split //, $topo;
#print "$in[0]\t$nres\n";
	$total_nres += $nres;
	if ($no_tm == 1){
#print "\n$in\t$file\t$nres\n";
		foreach $i (0..$nres-1){
			print OUT "$in[0]\tg\n";
		}
	}
	else {
		foreach $i (0..$#topo){
			print OUT "$in[0]\t$topo[$i]\n";
		}
	}
#print "\n";
}
#

print "$total_nres\n";
close OUT;
close IN;
