#!/usr/bin/perl

$cluster = $ARGV[0];
$file = "clusters_MP_seqids_90.out";
#$file = "d002_clustering_raw_scores/clusters_10.out";	#for MPs

open (OUT, ">cluster_".$cluster.".py") || die "cannot open input file $file\n";
#open (OUT, ">d002_clustering_raw_scores/pymol_sessions/cluster_".$cluster.".py") || die "cannot open input file $file\n";	#for MPs
print OUT "bg_color white\n";
print OUT "set orthoscopic=0\n";
print OUT "set depth_cue=1\n";
print OUT "set ray_shadows=0\n";
print OUT "set direct, 0.5\n\n";
print OUT "delete all\n\n";

open (IN, $file) || die "cannot open input file $file\n";
$lc = 0;
while ($in = <IN>){
	chomp $in;
	$in =~ s/^\s+//;
	@in = split /\s+/, $in;
	if ($in[0] == $cluster){
		$lc++;
		$lc == 1 ? $protein_to_align = $in[2] : print "";
		$id = substr($in[2], 1, 2);
#		print OUT "load /sb/meiler/PISCES/data/$id/$in[2].pdb\n";
		print OUT "load database_MPs/".substr($in[2], 0, 4)."biobcl.pdb\n";
		print OUT "align $in[2], $protein_to_align\n";
	}
	elsif ($in[1] == $cluster){
		$lc++;
		$lc == 1 ? $protein_to_align = $in[3] : print "";
		$id = substr($in[3], 1, 2);
#		print OUT "load /sb/meiler/PISCES/data/$id/$in[3].pdb\n";
		print OUT "load database_MPs/".substr($in[3], 0, 4)."biobcl.pdb\n";
		print OUT "align $in[3], $protein_to_align\n";
	}
}
close IN;

print OUT "hide everything\n";
print OUT "show cartoon, all\n";
print OUT "center\n";
print OUT "\n";
close OUT;
