#!/usr/bin/perl

#calculates the averages of the averages over an unbalanced dataset!!!

#needs fixing statistics_ds5_MPbeta_psi_jufo_j9d_prof.dat, statistics_ds4_MPbeta_psi_jufo_j9d_prof.dat, statistics_ds3_MPbeta_psi_jufo_j9d_prof.dat, statistics_ds1_MPbeta_psi_jufo_j9d_prof.dat, statistics_ds1_MPalpha_psi_jufo_j9d_prof.dat

$file_flag = $ARGV[0];

foreach $ind (1..5){
	$input = "statistics_ds".$ind."_".$file_flag.".dat";

	$flag_nd = 0;
	$lc = 0;
	open (IN, $input) || die "cannot open input file $input\n";
	while (my $in = <IN>){
		chomp $in;
		next if ($in !~ /\w/);
		$lc++;
		@in = split /\s+/, $in;
	
		#get correct method
		$in =~ /$method/ ? $flag_method = 1 : print "";
		$in =~ /METHOD/ && $in !~ /$method/ ? $flag_method = 0 : print "";

		#get 9-state
		$flag_method == 1 && ($in =~ /^9state/ || $in =~ /^sspred/ || $in =~ /^tmpred/ || $in =~ /^TMPred/) ? $flag_nd++ : print "";
		$flag_method == 1 && ($in =~ /^9state/ || $in =~ /^sspred/ || $in =~ /^tmpred/ || $in =~ /^TMPred/) ? $lc=0 : print "";

		#for percentages in 9state, odd $flag_nd for cnts, even $flag_nd for percentages, except for TMH and TMS
		if ($flag_nd == 2 && $lc >= 1 && $lc <= 9){
			foreach $k (1..9){
				if ($in[$k] eq "-"){
					$matrix_9d[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_9d[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for percentages in sspred
		if ($flag_nd == 4 && $lc >= 1 && $lc <= 3){
			foreach $k (1..3){
				if ($in[$k] eq "-"){
					$matrix_ss[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_ss[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for percentages in tmpred
		if ($flag_nd == 6 && $lc >= 1 && $lc <= 3){
			foreach $k (1..3){
				if ($in[$k] eq "-"){
					$matrix_tm[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tm[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for counts in tmhelix
		if ($flag_nd == 7 && $lc >= 1 && $lc <= 2){
			foreach $k (1..2){
				if ($in[$k] eq "-"){
					$matrix_tmh[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tmh[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for counts in tmstrand
		if ($flag_nd == 8 && $lc >= 1 && $lc <= 2){
			foreach $k (1..2){
				if ($in[$k] eq "-"){
					$matrix_tms[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tms[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#get the percentages for the tmhelix and tmstrand elements
	
		($matrix_tmh[$ind][1][1] == 0 && $matrix_tmh[$ind][1][2] == 0) ? $matrix_tmh[$ind][1][1] = 0.000001 : print "";
		($matrix_tmh[$ind][2][1] == 0 && $matrix_tmh[$ind][2][2] == 0) ? $matrix_tmh[$ind][2][1] = 0.000001 : print "";
		($matrix_tms[$ind][1][1] == 0 && $matrix_tms[$ind][1][2] == 0) ? $matrix_tms[$ind][1][1] = 0.000001 : print "";
		($matrix_tms[$ind][2][1] == 0 && $matrix_tms[$ind][2][2] == 0) ? $matrix_tms[$ind][2][1] = 0.000001 : print "";

		$matrix_tmh_pct[$ind][1][1] = $matrix_tmh[$ind][1][1] / ($matrix_tmh[$ind][1][1] + $matrix_tmh[$ind][1][2]);
		$matrix_tmh_pct[$ind][1][2] = $matrix_tmh[$ind][1][2] / ($matrix_tmh[$ind][1][1] + $matrix_tmh[$ind][1][2]);
		$matrix_tmh_pct[$ind][2][1] = $matrix_tmh[$ind][2][1] / ($matrix_tmh[$ind][2][1] + $matrix_tmh[$ind][2][2]);
		$matrix_tmh_pct[$ind][2][2] = $matrix_tmh[$ind][2][2] / ($matrix_tmh[$ind][2][1] + $matrix_tmh[$ind][2][2]);

		$matrix_tms_pct[$ind][1][1] = $matrix_tms[$ind][1][1] / ($matrix_tms[$ind][1][1] + $matrix_tms[$ind][1][2]);
		$matrix_tms_pct[$ind][1][2] = $matrix_tms[$ind][1][2] / ($matrix_tms[$ind][1][1] + $matrix_tms[$ind][1][2]);
		$matrix_tms_pct[$ind][2][1] = $matrix_tms[$ind][2][1] / ($matrix_tms[$ind][2][1] + $matrix_tms[$ind][2][2]);
		$matrix_tms_pct[$ind][2][2] = $matrix_tms[$ind][2][2] / ($matrix_tms[$ind][2][1] + $matrix_tms[$ind][2][2]);
	}
	close IN;
}
#print "$matrix_tms[1][2][2]\n";

#get sums for matrices
foreach $i (1..5){			#independent datasets
	foreach $j (1..9){		#rows
		foreach $k (1..9){	#columns

			$sum_matrix_9d[$j][$k]  += $matrix_9d[$i][$j][$k];
			$sum_matrix_ss[$j][$k]  += $matrix_ss[$i][$j][$k];
			$sum_matrix_tm[$j][$k]  += $matrix_tm[$i][$j][$k];
			$sum_matrix_tmh[$j][$k] += $matrix_tmh_pct[$i][$j][$k];
			$sum_matrix_tms[$j][$k] += $matrix_tms_pct[$i][$j][$k];
		}
	}
}

#get averages for matrices
foreach $i (1..5){			#independent datasets
	foreach $j (1..9){		#rows
		foreach $k (1..9){	#columns

			$avg_matrix_9d[$j][$k]  = $sum_matrix_9d[$j][$k] / 5;
			$avg_matrix_ss[$j][$k]  = $sum_matrix_ss[$j][$k] / 5;
			$avg_matrix_tm[$j][$k]  = $sum_matrix_tm[$j][$k] / 5;
			$avg_matrix_tmh[$j][$k] = $sum_matrix_tmh[$j][$k] / 5;
			$avg_matrix_tms[$j][$k] = $sum_matrix_tms[$j][$k] / 5;
		}
	}
}
#print "$avg_matrix_tms[2][1]\n";

#get differences for stdev
foreach $i (1..5){			#independent datasets
	foreach $j (1..9){		#rows
		foreach $k (1..9){	#columns

			$diff_matrix_9d[$j][$k]  += ($matrix_9d[$i][$j][$k] - $avg_matrix_9d[$j][$k])**2;
			$diff_matrix_ss[$j][$k]  += ($matrix_ss[$i][$j][$k] - $avg_matrix_ss[$j][$k])**2;
			$diff_matrix_tm[$j][$k]  += ($matrix_tm[$i][$j][$k] - $avg_matrix_tm[$j][$k])**2;
			$diff_matrix_tmh[$j][$k] += ($matrix_tmh_pct[$i][$j][$k] - $avg_matrix_tmh[$j][$k])**2;
			$diff_matrix_tms[$j][$k] += ($matrix_tms_pct[$i][$j][$k] - $avg_matrix_tms[$j][$k])**2;
		}
	}
}

#print avg and stdev for 9d
print "$input\n\n$method\tMC-H\t\tMC-E\t\tMC-C\t\tTR-H\t\tTR-E\t\tTR-C\t\tSO-H\t\tSO-E\t\tSO-C\n";
foreach $j (1..9){		#rows

	$j == 1 ? print "MC-H\t" :
	$j == 2 ? print "MC-E\t" :
	$j == 3 ? print "MC-C\t" :
	$j == 4 ? print "TR-H\t" :
	$j == 5 ? print "TR-E\t" :
	$j == 6 ? print "TR-C\t" :
	$j == 7 ? print "SO-H\t" :
	$j == 8 ? print "SO-E\t" :
	$j == 9 ? print "SO-C\t": print "";

	foreach $k (1..9){	#columns

		$stdev_9d[$j][$k] = sqrt($diff_matrix_9d[$j][$k] / 5);
		$stdev_ss[$j][$k] = sqrt($diff_matrix_ss[$j][$k] / 5);
		$stdev_tm[$j][$k] = sqrt($diff_matrix_tm[$j][$k] / 5);
		$stdev_tmh[$j][$k] = sqrt($diff_matrix_tmh[$j][$k] / 5);
		$stdev_tms[$j][$k] = sqrt($diff_matrix_tms[$j][$k] / 5);

		printf "%5.2f", $avg_matrix_9d[$j][$k];
		printf " +/-%5.2f\t", $stdev_9d[$j][$k];
	}
	print "\n";
}
print "\n\n";

#print avg and stdev for sspred
print "$method\tH\t\tE\t\tC\n";
foreach $j (1..3){		#rows

	$j == 1 ? print "H\t" :
	$j == 2 ? print "E\t" :
	$j == 3 ? print "C\t": print "";

	foreach $k (1..3){	#columns

		printf "%5.2f", $avg_matrix_ss[$j][$k];
		printf " +/-%5.2f\t", $stdev_ss[$j][$k];
	}
	print "\n";
}
print "\n\n";

#print avg and stdev for tmpred
print "$method\tMC\t\tTR\t\tSO\n";
foreach $j (1..3){		#rows

	$j == 1 ? print "MC\t" :
	$j == 2 ? print "TR\t" :
	$j == 3 ? print "SO\t": print "";

	foreach $k (1..3){	#columns

		printf "%5.2f", $avg_matrix_tm[$j][$k];
		printf " +/-%5.2f\t", $stdev_tm[$j][$k];
	}
	print "\n";
}
print "\n\n";

#print avg and stdev for tmalpha
print "$method\tTMH\t\tnTMH\n";
foreach $j (1..2){		#rows

	$j == 1 ? print "TMH\t" :
	$j == 2 ? print "nTMH\t": print "";

	foreach $k (1..2){	#columns

		printf "%5.2f", $avg_matrix_tmh[$j][$k]*100;
		printf " +/-%5.2f\t", $stdev_tmh[$j][$k]*100;
	}
	print "\n";
}
print "\n\n";

#print avg and stdev for tmalpha
print "$method\tTMS\t\tnTMS\n";
foreach $j (1..2){		#rows

	$j == 1 ? print "TMS\t" :
	$j == 2 ? print "nTMS\t": print "";

	foreach $k (1..2){	#columns

		printf "%5.2f", $avg_matrix_tms[$j][$k]*100;
		printf " +/-%5.2f\t", $stdev_tms[$j][$k]*100;
	}
	print "\n";
}
print "\n";

