#!/usr/bin/perl 

$dataset = $ARGV[0];	#1 to 5
$input = "TMkink_locations".$dataset.".txt";
$output = "TMkink-method_results".$dataset.".txt";

#reads kink input file for real kinks
open (REAL, $input) || die "cannot open input file $input\n";
open (OUT, ">$output") || die "cannot open output file $output\n";
while ($in = <REAL>){
	@in = split /\s+/, $in;
	$seqid = $in[1];
	$chain = $in[2];
	
	$pred_file = "TMkink_output/".$chain.".TMkink";

	#reads TMkink output file
	open (PRED, $pred_file) || die "cannot open predicted file $pred_file\n";
	while ($in1 = <PRED>){
		@in1 = split /\s+/, $in1;
		$residueID = $in1[0];
		if ($residueID >= $seqid - 5 && $residueID <= $seqid + 5){
			print OUT "$chain\treal: $seqid\tpredicted: $residueID\n";
		}
#		else {
#			print "$chain\treal: $seqid\n";
#		}
	}
	close PRED;
	print OUT "\n";
}
close OUT;
close IN;

