#!/usr/bin/perl 

$folds = "folds.ls";
$input = "dataset".$ARGV[0].".ls";

#read folds file
open (FOLDS, $folds) || die "cannot open folds file\n";
while ($in = <FOLDS>){
	chomp $in;
	@in = split /\s+/, $in;
	push @protein, $in[0];
	push @fold, $in[1];
}
close FOLDS;

#read oligomeric state dictionary
open (OLIGO, "oligomeric_state_dictionary.txt") || die "cannot open folds file\n";
while ($in = <OLIGO>){
	chomp $in;
	@in = split /\s+/, $in;
	push @protein_oligo, substr($in[0], 0, 4);
	push @oligo, $in[1];
}
close OLIGO;

open (INPUT, $input) || die "cannot open folds file\n";
while ($in = <INPUT>){
	chomp $in;
	@in = split /\s+/, $in;
	$chain = $in[0];
	$environment = $in[1];
	next unless ($environment eq "Membrane");
	foreach $i (0..$#protein){
		foreach $j (0..$#oligo){
#			if ($chain =~ $protein[$i] && $environment eq "Membrane" && $protein[$i] eq $protein_oligo[$j]){
			if ($chain =~ $protein[$i] && $protein[$i] eq $protein_oligo[$j]){
#				$fold[$i] eq "a" ? print "$chain\t$environment\t$oligo[$j]\t$fold[$i]\n" : print "";
				$fold[$i] eq "b" ? print "$chain\t$environment\n" : print "";
			}
		}
	}
#	foreach $j (0..$#oligo){
#		if ($environment eq "Soluble" && $protein[$i] eq $protein_oligo[$j]){
#			print "$chain\t$environment\t$oligo[$j]\n";
#		}
#	}
}
close INPUT;


